#include <stdio.h>
#include <fcntl.h>
#include <sys/soundcard.h>
#include <stdlib.h>

/*
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <unistd.h>
*/


unsigned char final_wave[2048];
int waveptr;
int wavflag;
int sound_fd;
unsigned char *Csound[16];

void snd_output(unsigned int tamano,unsigned char *wave);


/* ---- play un sonido del bloque n ----- */
void Splayblock(int n)
{
unsigned int  ta,z;
unsigned char *base;
        base=Csound[n];
        
        base+=3;
        ta=*base;
        base--;
        ta=ta<<8;
        z=*base&0x00FF; ta+=z;
        base--;
        ta=ta<<8;
        z=*base&0x00FF; ta+=z;
        base--;
        ta=ta<<8;
        z=*base&0x00FF; ta+=z;
        base+=4;
        
        snd_output(ta,base);
}

/* ---- lee un sonido *.raw a un bloque nuevo ---- */
void Sloadblock(int n,char *nombre)
{
 FILE *pf;
unsigned int z,zz,ta;
unsigned char *base;

	if ((pf=fopen(nombre,"rb"))==NULL)
           { printf("error 1 Sloadblock"); goto salir;}
	if(Csound[n]!=0) free(Csound[n]);
        fseek(pf,0,2);   ta=ftell(pf);
        Csound[n]=malloc(ta+4);
        if(Csound[n]==0){error(8); goto fin;}
        base=Csound[n];
        *base=ta&0x00FF;
        base++;
	*base=(ta>>8)&0x00FF;
	base++;
        *base=(ta>>16)&0x00FF;
	base++;
        *base=(ta>>24)&0x00FF;
	base++;
        zz=fseek(pf,0,0);
        z=fread(base,ta,1,pf);
        if(0==z) printf("error 2  Sloadblock \n"); 
fin:
   	fclose(pf);
salir:
;
}





void play_raw(char *nombre)
{

 FILE *pf;
 int z,zz,ta;
 unsigned char onda[8000];
    if (sound_fd)
       {
    	if((pf=fopen(nombre,"rb"))==NULL)
		  { error(2);}
		 else
		  {   
                     zz=fseek(pf,0,2);
                     ta=ftell(pf);
                     zz=fseek(pf,0,0);
                     do
                     {
                         if(ta<8000) zz=ta; else zz=8000;
                         z=fread(onda,zz,1,pf);
                         write(sound_fd,&onda,zz);
                         ta-=8000;
                     }
                     while(ta>0);
                     fclose(pf);
                  }
       }
}



int snd_open( int sample_rate)
{
    int tmp;
    int result;
    int sound_rate;
    int sound_frag;

    waveptr = 0;
    wavflag = 0;
    
    printf("opening /dev/dsp...");
    sound_fd = open("/dev/dsp", O_WRONLY);
    if (sound_fd < 0) {
	perror("failed");
	sound_fd = 0;
	return 0;
    } else {
	printf("done.\n");
    }
    
    printf("setting unsigned 8-bit format...");
    tmp = AFMT_U8;
    result = ioctl(sound_fd, SNDCTL_DSP_SETFMT, &tmp);
    if (result < 0) {
	perror("failed");
	close(sound_fd);
	sound_fd = 0;
	return 0;
    } else {
	printf("done.\n");
    }
    
    printf("setting mono mode...");
    tmp = 0;
    result = ioctl(sound_fd, SNDCTL_DSP_STEREO, &tmp);
    if (result < 0) {
	perror("failed");
	close(sound_fd);
	sound_fd = 0;
	return 0;
    } else {
	printf("done.\n");
    }
    
    sound_rate = sample_rate;
    printf("setting sound rate to %dHz...", sound_rate);
    result = ioctl(sound_fd, SNDCTL_DSP_SPEED, &sound_rate);
    if (result < 0) {
	perror("failed");
	close(sound_fd);
	sound_fd = 0;
	return 0;
    } else {
	printf("got %dHz...done.\n", sound_rate);
    }

    /* high word of sound_frag is number of frags, low word is frag size */
    sound_frag = 0x00080008;
    printf("setting soundfrags...");
    result = ioctl(sound_fd, SNDCTL_DSP_SETFRAGMENT, &sound_frag);
    if (result < 0) {
	perror("failed");
	close(sound_fd);
	sound_fd = 0;
	return 0;
    } else {
	printf("done.\n");
    }

    return 1;
}

void snd_close(void)
{
    if (sound_fd) {
	close(sound_fd);
        printf("Cerrando sonido\n");
    }
}


void snd_output(unsigned int tamano,unsigned char *wave)
{
           write(sound_fd,wave,tamano);
}



